<template>
    <i v-if="isImageLiked(image._id)" class="fa-solid fa-heart icon-svg filled"  @click="likeImage()"></i>
    <i v-else class="fa-regular fa-heart icon-svg unfilled" @click="likeImage()"></i>
</template>



<script>

import axios from 'axios';
import { useStore } from '../store/store';
import { mapState } from 'pinia';

export default {

name: 'LikeImage',
props: {
    image: Object,
},

data(){
    return{
        isLiked: false
    }
},


computed: {
        ...mapState(useStore, ['isImageLiked'])
    },

methods:{
        likeImage(){
                const store = useStore()
                axios.post('http://localhost:3500/api/like/' + this.image._id, {
                    userId: localStorage.getItem("user"),
                    userImage: this.image.user
                })
                .then(res =>{
                    console.log(res)
                    if(res.data.type == "created"){
                        store.setImageLiked(this.image._id, res.data.like)
                        this.$emit('incrementLike', res.data.like)
                    }
                    else{
                        store.setImageLiked(this.image._id, false)   
                        this.$emit('decrementLike', res.data.like)
                    }
                })
                .catch(err =>{
                    console.log(err);
                })
        }
    }
}


</script>

<style scoped>
    .filled{
        color: red;
        /* display: none; */
        transition-timing-function: ease-out;
    }
    i{
        
        margin-right: 5px;
    }
</style>